﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Web;
using EPiServer.Web.Hosting;
using System.Net;

namespace Nansen.Viddler.Hosting
{
    public class ViddlerHttpHandler : IHttpHandler
    {
        #region IHttpHandler Members

        public bool IsReusable
        {
            get { return true; }
        }

        public void ProcessRequest(HttpContext context)
        {
            var file = VirtualPathHandler.Instance.GetFile(context.Request.Url.PathAndQuery, true) as ViddlerFile;

            if (file != null && file.Video != null)
            {
                context.Response.Redirect(file.PlayerUrl);
            }
            else
            {
                context.Response.Clear();
                context.Response.StatusCode = (int) HttpStatusCode.NotFound;
                context.Response.End();
            }
        }

        #endregion
    }
}
