﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using EPiServer.Web.Hosting;

namespace Nansen.Viddler.Hosting
{
    public class ViddlerUnifiedSummary : UnifiedSummary
    {
        private readonly ViddlerFile _file;

        public ViddlerUnifiedSummary(ViddlerFile file)
        {
            this._file = file;
        }

        public override void SaveChanges()
        {
            if (!(this._file is ViddlerTempFile))
            {
                var viddler = new Viddler();
                
                // h4x
                foreach(string key in System.Web.HttpContext.Current.Request.Form.AllKeys)
                {
                    if(key.Contains("ViddlerTitle"))
                    {
                        _file.Video.Title = System.Web.HttpContext.Current.Request.Form[key];
                    }
                    else if(key.Contains("ViddlerDescription"))
                    {
                        _file.Video.Description = System.Web.HttpContext.Current.Request.Form[key];                        
                    }
                    else if(key.Contains("ViddlerTags"))
                    {
                        _file.Video.Tags = System.Web.HttpContext.Current.Request.Form[key].Split(',').ToList();                        
                    }
                }

                viddler.SetDetails(_file.Video);
            }
        }

        public override bool CanPersist
        {
            get { return true; }
        }

        public override IDictionary Dictionary
        {
            get
            {
                var summary = new Dictionary<string, string>();

                if (_file.Video != null)
                {
                    summary.Add("ViddlerTitle", _file.Video.Title);
                    summary.Add("ViddlerDescription", _file.Video.Description);

                    string tags = string.Empty;

                    foreach (string tag in _file.Video.Tags)
                    {
                        tags += tag.Trim() + ",";
                    }

                    tags = !string.IsNullOrEmpty(tags) ? tags.Remove(tags.Length - 1) : string.Empty;

                    summary.Add("ViddlerTags", tags);
                }

                return summary;
            }
        }
    }
}
