﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using EPiServer.Core;
using EPiServer.PlugIn;
using Nansen.Viddler.Properties;

namespace Nansen.Viddler.SpecializedProperties
{
    [PageDefinitionTypePlugIn]
    public class PropertyViddlerVideo : PropertyLongString
    {
        //f = false, t = true
        // {0} = width
        // {1} = height
        // {2} = Id
        // {3} = autoplay
        // {4} = disablebranding
        private const string EMBED_HTML_FORMAT = "<object classid=\"clsid:D27CDB6E-AE6D-11cf-96B8-444553540000\" width=\"{0}\" height=\"{1}\" id=\"viddlerplayer-{2}\"><param name=\"wmode\" value=\"opaque\"> <param name=\"movie\" value=\"http://www.viddler.com/player/{2}/\" /><param name=\"autoplay\" value=\"{3}\" /><param name=\"disablebranding\" value=\"{4}\" /><param name=\"allowScriptAccess\" value=\"always\" /><param name=\"allowFullScreen\" value=\"true\" /><embed src=\"http://www.viddler.com/player/{2}/\" width=\"{0}\" height=\"{1}\" type=\"application/x-shockwave-flash\" allowScriptAccess=\"always\" wmode=\"opaque\" allowFullScreen=\"true\" flashvars=\"autoplay={3}&disablebranding={4}\" name=\"viddlerplayer-{2}\"></embed></object>";

        public override IPropertyControl CreatePropertyControl()
        {
            return new PropertyViddlerVideoControl();
        }

        // Vill inte lagra embed-html:en utifall visningen ändras, så vi kör på detta om man vill ha ut lite html
        public string EmbedHtml
        {
            get
            {
                if (!this.IsNull)
                {
                    PropertyViddlerVideoData videoData = PropertyViddlerVideoData.SerializeFromString(base.Value as string);

                    int width = 437;
                    int height = 370;

                    if(!string.IsNullOrEmpty(videoData.SizePreset))
                    {
                        foreach(string preset in Settings.Default.SizePresets.Split('|'))
                        {
                            if(preset.Split(';')[0] == videoData.SizePreset)
                            {
                                width = int.Parse(preset.Split(';')[1]);
                                height = int.Parse(preset.Split(';')[2]);
                            }
                        }
                    }

                    return string.Format(EMBED_HTML_FORMAT, width, height, videoData.Id, videoData.Autoplay ? "t" : "f", videoData.DisableBranding ? "t" : "f");
                }

                return string.Empty;
            }
        }
    }
}
