﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Serialization;
using System.IO;

namespace Nansen.Viddler.SpecializedProperties
{
    [Serializable]
    public class PropertyViddlerVideoData
    {
        public string Id { get; set; }
        public bool Autoplay { get; set; }
        public bool DisableBranding { get; set; }
        public string SizePreset { get; set; }

        public static PropertyViddlerVideoData SerializeFromString(string xml)
        {
            var serializer = new XmlSerializer(typeof(PropertyViddlerVideoData));

            using (var reader = new StringReader(xml))
            {
                return serializer.Deserialize(reader) as PropertyViddlerVideoData;
            }
        }

        public static string SerializeToString(PropertyViddlerVideoData videoData)
        {
            var serializer = new XmlSerializer(typeof(PropertyViddlerVideoData));

            using (var writer = new StringWriter())
            {
                serializer.Serialize(writer, videoData);

                return writer.ToString();
            }
        }
    }
}
